program gp4XLP;
{$apptype console}
const
{   imax = 150; jmax = 250; iprint = 1;}
{   imax = 250; jmax = 200+imax; iprint = 0;}
   imax = 500; jmax = 260+imax; iprint = 0;  {1999.6.23}
{   imax = 75; jmax = 125; iprint = 1;}
{   imax = 55; jmax = 95; iprint = 0;}
   big = 1.0e9;
   epsiron = 1.0e-6;
   zero = '.   ';
type
   vptr = ^v;
   v = array[0..jmax] of real;
   tptr = array[-9..imax] of vptr;
var
   t : tptr;
   title : string;
   m, n, mn : integer;
   pname : array[1..jmax] of string;
   rname : array[1..imax] of string;
   i, j, idmy, ierr : integer;
   num : array[1..imax + jmax] of integer;
   lt : array[1..imax] of integer;
   a, dmy : real;
   ipivot, jpivot : integer;
   relation, relation2 : array[1..imax] of string[2];
   priority : array[1..imax] of byte;
   gmax : byte;
   process_work, process_shadow_price : array[1..jmax] of real;
   goal : array[1..imax] of real;
   sur_rest, sur_shadow_price : array[1..imax] of real;
   sluck_rest, sluck_shadow_price : array[1..imax] of real;
   dfile : text;

(*---------------------------------------------------------------------------*)
procedure send_end_msg;
begin
   assign(dfile, 'XLP_DMY.$$$');
   rewrite(dfile);
   close(dfile);
end;

(*---------------------------------------------------------------------------*)
procedure preparation;
begin
   mn := m + n;
   (* clear memory  *)
   for i := -9 to m do
      for j := 0 to mn do
         t[i]^[j] := 0.0;
   for i := 1 to m do begin
      relation[i] := '';
      priority[i] := 0;
      rname[i] := '';
      lt[i] := 0;
      sur_rest[i] := 0.0;
      sluck_rest[i] := 0.0;
   end;
   for j := 1 to n do begin
      pname[j] := '';
      num[j] := 0;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure input_data;                    (* input data on framework of model *)
var
   ierr : integer;
begin
   readln(title);
   readln(m,n);
   ierr:=0;
   if n + m > jmax - 1 then begin
      writeln;
      writeln('***** vZX{񎮂̐ ',jmax-1:3,'  łȂ΂Ȃ܂B');
      ierr := 1;
   end;
   if m > imax - 1 then begin
      writeln;
      writeln('***** 񎮂̐ ',imax-1:3,'  łȂ΂Ȃ܂B');
      ierr := 1;
   end;
   if ierr <> 0 then begin
      send_end_msg;
      halt;
   end;
   preparation;

   (* input name of process and restraint *)
   for j := 1 to n do readln(pname[j]);
   for i := 1 to m do readln(rname[i]);

   (* relation and priority of constraint *)
   gmax := 0;
   for i := 1 to m do begin
      readln(relation[i], priority[i]);
      if priority[i] > gmax then gmax := priority[i];
   end;
   
   for i := 1 to m do begin
      if relation[i] = 'eq' then relation2[i] := ''
      else if relation[i] = 'ge' then relation2[i] := ''
      else relation2[i] := '""';
   end;
   
   (* technical and return coefficient, value of constraint *)
   i := 0;
   while (i <> 30000) do begin
      read(i, j, a);
      if eoln then readln;
      if (i <> 30000) then begin
         if (i>m) or (j>n) then begin
            write('***** sԍ邢͗ԍ傫܂B-----  ');
            writeln(i:4,j:4,a:10:3);
            ierr := -1;
         end else begin
            t[i]^[j]:=a;
         end;
      end;
   end;
   if (ierr=-1) then begin
      send_end_msg;
      halt;
   end;
   {save constance of constraint formula in initial solution}
   for i := 1 to m do goal[i] := t[i]^[0];
end;

(*---------------------------------------------------------------------------*)
function fn_test_zero(dmy : real):boolean;
begin
   if (-epsiron < dmy) and (dmy < epsiron) then 
      fn_test_zero := true
   else
      fn_test_zero := false;
end;

(*---------------------------------------------------------------------------*)
procedure print_tableau;   {Hidden part of tableau is not printed}
const
   spc10 = '          ';
   keta = 6;
var
   je, js, jj : integer;
begin
   js := 0;
   writeln('*****  *****  ',title);
   while (js <= n) do begin
      je := js + (keta-1);
      if (je > n) then
         je := n;
      
      write(' ':19);
      for jj := js to je do
         write(jj:10);
      writeln;
      
      write(' ':19);
      for jj := js to je do
         if (jj = 0) or (jj > n) then
            write(spc10)
         else
            write('  ':2,copy(pname[jj],1,8):8);
      writeln;
      
      write(' ':19);
      for jj := js to je do
         if (jj = 0) or (jj > n) then
            write(spc10)
         else
            write('  ':2,copy(pname[jj],9,8):8);
      writeln;
      
      for i:= 1 to m do begin
         if i < 1 then
            write(i:2,' ':1,' z-c':8, -i:2, ' ':6)
         else
            write(i:2, ' ':1, copy(rname[i],1,10):10, priority[i]:2, relation2[i]:4);
         for jj := js to je do
            if fn_test_zero(t[i]^[jj]) then 
               write(zero:10) 
            else
               write(t[i]^[jj]:10:3);
         writeln;
      end;
      writeln;
      js := je + 1;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure print_tableau2;   {Hidden part of tableau is also printed}
const
   spc10 = '          ';
   keta = 6;
var
   je, js, jj : integer;
begin
   js:=0;
   writeln(title);
   while (js<=mn) do begin
      je:=js+(keta-1);
      if (je>mn) then
         je:=mn;
      
      write(' ':19);
      for jj:=js to je do
         write(jj:10);
      writeln;
      
      write(' ':19);
      for jj:=js to je do
         if (jj = 0) or (jj > n) then
            write(spc10)
         else
            write('  ':2,copy(pname[jj],1,8):8);
      writeln;
      
      write(' ':19);
      for jj:=js to je do
         if (jj = 0) or (jj > n) then
            write(spc10)
         else
            write('  ':2,copy(pname[jj],9,8):8);
      writeln;
      
      for i:=-gmax to m do begin
         if i < 1 then
            write(i:2,' ':1,' z-c':8, -i:2, ' ':6)
         else
            write(i:2, ' ':1, copy(rname[i],1,10):10, priority[i]:2, relation2[i]:4);
         for jj:=js to je do
            if fn_test_zero(t[i]^[jj]) then 
               write(zero:10) 
            else
               write(t[i]^[jj]:10:3);
         writeln;
      end;
      writeln;
      js := je + 1;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure build_initial_solution;
begin
   mn:=m+n;
   (* nunbering of basis variable *)
   for i := 1 to m do
      lt[i] := i + 2000;
   
   (* numbering of non basis variable *)
   for  j:=1 to mn do begin
      if (j > n) then
         num[j]:=j-n+1000
      else
         num[j]:=j;
   end;
   
   for i:=1 to m do begin
      t[i]^[ i + n] := -1;
      (* value of criterion *)
      if (relation[i] = 'eq') or (relation[i] = 'le') then
         t[-priority[i]]^[n + i] := -1;
      (* trnsform to basis form for lower limit *)
      if (relation[i] = 'eq') or (relation[i] = 'ge') then
         for j := 0 to mn do
            t[-priority[i]]^[j] := t[-priority[i]]^[j] + t[i]^[j];
   end;
end;

(*---------------------------------------------------------------------------*)
function fn_ipivot : integer;
var
   min : real;
begin
   fn_ipivot := 0;
   min := 1.0e10;
   for i := 1 to m do begin
      if t[i]^[jpivot] > epsiron then begin
         dmy := t[i]^[0] / t[i]^[jpivot];
         if dmy < min then begin
            min := dmy;
            fn_ipivot := i;
         end;
      end;
   end;
   if min > 1.0e9 then fn_ipivot := 0;
end;

(*---------------------------------------------------------------------------*)
function fn_jpivot : integer;
label
   exit1;
begin
   for j := 1 to mn do begin
      for i := 0 downto -gmax do begin
         if t[i]^[j] < -epsiron then goto exit1;
         if t[i]^[j] > epsiron then begin
            fn_jpivot := j;
            exit;
         end;
      end;
      exit1:;
   end;
   fn_jpivot := 0;       {œKꂽ}
end;

(*---------------------------------------------------------------------------*)
procedure sweep;
var
   ta : real;
begin
   (* transform  sweeping row *)
   ta:=t[ipivot]^[jpivot];
   for j:=0 to mn do
      t[ipivot]^[j] := t[ipivot]^[j] / ta;
   t[ipivot]^[jpivot] := 1.0 / ta;
   
   (* transform  non-sweeping row *)
   for i:=-gmax to m do begin
      if (i<>ipivot) then begin
         ta := t[i]^[jpivot];
         for j := 0 to mn do
            t[i]^[j] := t[i]^[j] - t[ipivot]^[j] * ta;
         t[i]^[jpivot] := 0.0 - t[ipivot]^[jpivot] * ta;
      end;
   end;
   
   (* exchange label of basis variable and non-basis variable *)
   idmy := lt[ipivot];
   lt[ipivot] := num[jpivot];
   num[jpivot] := idmy;
end;

(*---------------------------------------------------------------------------*)
procedure solve;
var
   tcon : text;
begin
   assign(tcon, 'con');
   rewrite(tcon);
   write(tcon,'  vZł':1);
   while true do begin
      write(tcon,'':1);
      jpivot := fn_jpivot;
      if jpivot = 0 then exit;
      ipivot := fn_ipivot;
      if ipivot = 0 then exit;
      sweep;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure summarize_result;
begin
   for i := 1 to m do begin
      if lt[i] > 2000 then begin
         sur_rest[lt[i]-2000] := t[i]^[0];          (* rest of restraint *)
         {sur_shadow_price[lt[i]-2000] := 0;         (* shadow price *)}
      end else if lt[i] > 1000 then begin
         sluck_rest[lt[i]-1000] := t[i]^[0];           (* rest of restraint *)
         {sluck_shadow_price[lt[i]-1000] := 0;           (* shadow price *)}
      end else begin
         process_work[lt[i]] := t[i]^[0];           (* working level *)
         {process_shadow_price[lt[i]] := 0;         (* shadow price *)}
      end;
   end;
   for j := 1 to n + m do begin
      if num[j] > 2000 then begin
         idmy := num[j]-2000;
         {sur_shadow_price[idmy] := t[-priority[idmy]]^[j]; (* shadow price *)}
         sur_rest[idmy] := 0;               (* rest of restraint *)
      end else if num[j] > 1000 then begin
         idmy := num[j]-1000;
         {sluck_shadow_price[idmy] := t[-priority[idmy]]^[j]; (* shadow price *)}
         sluck_rest[idmy] := 0;                  (* rest of restraint *)
      end else begin
         idmy := num[j];
         {
         process_shadow_price[idmy] := t[-priority[idmy]]^[j];(* shadow price *)
         Is this all rigth ? Shadow price is meaningful ?
         }
         process_work[idmy] := 0;                    (* working level *)
      end;
   end;
end;
   

(*---------------------------------------------------------------------------*)
procedure print_result;
var
   solution, luck, rest : array[1..imax] of real;
begin
   writeln(gmax:5);
   writeln(title:1);
   writeln('ڕW̖BʁF');
   write(' ':2, '':10,',');
   if fn_test_zero(t[0]^[0]) then writeln(zero:13) else writeln(t[0]^[0]:13:3);
   for i := -1 downto -gmax do begin
      write(' ':2,'':4, -i:2, 'ڕW':4,',');
      if fn_test_zero(t[i]^[0]) then writeln(zero:13) else writeln(t[i]^[0]:13:3);
   end;
   
   for i := 1 to m do begin
         solution[i] := goal[i] - sur_rest[i] + sluck_rest[i];
      if relation[i] = 'le' then begin
         luck[i] := sluck_rest[i];
         rest[i] := sur_rest[i];
      end else if relation[i] = 'ge' then begin
         luck[i] := sur_rest[i];
         rest[i] := sluck_rest[i];
      end else begin   {'eq'}
         luck[i] := sur_rest[i] + sluck_rest[i];
         rest[i] := 0.0;
      end;
   end;
   
   (*
   writeln('ڕWE񎮕    ڕWE':22, '  BEc':12, {'݉i':10,} 'BEs':14{, '݉i':10});
   *)
{--z------1---------2---------3---------4---------5---------6---------7--------}
   writeln('ڕWE񎮕ʂ̖BʓF');
   writeln('"", ڕWE, ڕW, ֌W, ڕWl, l, B, ߒB');
{'       W            ڕWl      l   Bisj ߁icʁj');}
   for i := 1 to m do begin
      write(' ':1, i:3, ',"', rname[i]:1, '",', priority[i]:2, ',', relation2[i]:4, ',', goal[i]:12:3, ',');
      if fn_test_zero(solution[i]) then write(zero:12, ',') else write(solution[i]:12:3, ',');
      if fn_test_zero(luck[i]) then write(zero:12, ',') else write(luck[i]:12:3, ',');
      if fn_test_zero(rest[i]) then writeln(zero:12) else writeln(rest[i]:12:3);
   end;
   
   writeln('"", vZX, ғ');
   for i := 1 to n do begin
      write(' ':1, i:3, ',"', pname[i]:1, '",');
      if fn_test_zero(process_work[i]) then
         writeln(zero:18)
      else
         writeln(process_work[i]:18:3{, process_shadow_price[i]:12:3});
   end;
end;

(*---------------------------------------------------------------------------*)
function heapfunc(size : word) : integer ; far;
begin
   heapfunc := 1;
end;

{ main -----------------------------------------------------------------------}
begin
{   heaperror := @heapfunc;}
   for i := -9 to imax do new(t[i]);
   if t[imax] = nil then begin
      writeln('***** [Ȃ̂ŁCsł܂B*****');
      send_end_msg;
      halt;
   end;
   input_data;
   build_initial_solution;
   if iprint = 1 then print_tableau;
   solve;
   summarize_result;
   print_result;
   for i := -9 to imax do dispose(t[i]);
   send_end_msg;
end.
